const $ = require('jquery');
const _ = require('underscore');
const Backbone = require('backbone');
const request = require('request');

const DataItem = Backbone.Model.extend({

});

const DataCollection = Backbone.Collection.extend({
  'model': DataItem
});

// const dataCollection = new dataCollection();

const DataItemView = Backbone.View.extend({
  'tagName': 'div',
  'className' : 'mui-row',
  'template': _.template(`
            <div class="mui-col-xs-4 mui-col-md-4"><%=id%></div>
            <div class="mui-col-xs-8 mui-col-md-8"><%=company_name%></div>    
          `),
  'initialize': function() {
    this.render();
  },
  'render': function() {
    this.$el.html(this.template(this.model.toJSON()));
  }
});

const DataListModel = Backbone.Model.extend({
  'defaults' : function (obj) {
      // return a new object
      return {
        'update' : new Date().getTime()
      };
    }, 'initialize': function() {
      this.dataCollection = new DataCollection();
      this.listenTo(this, 'change:update', this.onChange);
      this.getData();
    },
    'onChange': function() {
      this.getData();
    },
    'getData': function() {
      request({
        'url': `${window.loc.origin}/data`,
        'method': 'GET', 'qs': {

        }
      }, function(err, res, body) {
        if (err)
          console.error(err);
        else {
          const fsJSON = JSON.parse(body);

          this.dataCollection.reset(fsJSON);

          this.logUpdate();
        }
      }.bind(this));
    }, 'logUpdate': function() {
      const time = new Date().getTime() ;

      this.set('time', time);

      this.timerID = setTimeout(
        () => this.tick(),
        30 * 1000
      );
    },
    'tick': function() {
      this.set('update', new Date().getTime());
    }

});

const DataListView = Backbone.View.extend({
  'initialize': function(options) {
      this.model.dataCollection.bind('reset', this.render, this);

    },
    'render' : function() {

      this.$el.empty();

      this.model.dataCollection.each(function(item) {
        const niView = new DataItemView({ 'model': item });

        this.$el.append(niView.el);
      }, this);

    }

});

module.exports = { DataListModel, DataListView };
